# Dvojnásobek zadaného čísla.
x = 5

# {x >= 0}
y = 0
z = 0
while z < x:
    y = y + 2
    z = z + 1
# {y == 2 * x}


print(y)

# Následuje důkaz pravdivosti trojice.

# Aby bylo možné použít pravidlo cyklu,
# musíme dokázat:

# {2 * z == y and z <= x and z < x}
# y = y + 2
# z = z + 1
# {2 * z == y and z <= x}

# Trojici dokážeme odspodu.
# Použijeme pravidlo přiřazení:

# {2 * (z + 1) == y and (z + 1) <= x}
# z = z + 1
# {2 * z == y and z <= x}

# Zjednodušíme prekondici:

# {2 * (z + 1) == y and z < x}
# z = z + 1
# {2 * z == y and z <= x}

# Předchozí trojici si označíme (1).
    
# Použijeme pravidlo přiřazení:

# {2 * (z + 1) == (y + 2) and z < x}
# y = y + 2
# {2 * (z + 1) == y and z < x}

# Zjednodušíme prekondici:

# {2 * z == y  and z < x}
# y = y + 2
# {2 * (z + 1) == y and z < x}

# Pravidlo skládání na předchozí trojici
# a na trojici označenou (1):

# {2 * z == y  and z < x}
# y = y + 2
# z = z + 1
# {2 * z == y and z <= x}

# Přeformulujeme:

# {2 * z == y and z <= x and z < x}
# y = y + 2
# z = z + 1
# {2 * z == y and z <= x}

# Dokázali jsme, co jsme chtěli,
# a můžeme použít pravidlo cyklu:

# {2 * z == y and z <= x}
# while z < x:
#     y = y + 2
#     z = z + 1
# {2 * z == y and z <= x and not z < x}

# Zjednodušíme postkondici:

# {2 * z == y and z <= x}
# while z < x:
#     y = y + 2
#     z = z + 1
# {2 * z == y and z == x}

# Oslabíme postkondici:

# {2 * z == y and z <= x}
# while z < x:
#     y = y + 2
#     z = z + 1
# {2 * x == y}

# Předchozí trojici si označíme (2).

# Použijeme pravidlo přiřazení:

# {2 * 0 == y and 0 <= x}
# z = 0
# {2 * z == y and z <= x}

# Předchozí trojici si označíme (3).

# Použijeme pravidlo přiřazení:

# {2 * 0 == 0 and 0 <= x}
# y = 0
# {2 * 0 == y and 0 <= x}

# Zjednodušíme prekondici:

# {0 <= x}
# y = 0
# {2 * 0 == y and 0 <= x}

# Použijeme pravidlo skládání na předchozí trojici
# a na trojici označenou (3):

# {0 <= x}
# y = 0
# z = 0
# {2 * z == y and z <= x}

# Na závěr použijeme pravidlo skládání na předchozí trojici
# a na trojici označenou (2):

# {0 <= x}
# y = 0
# z = 0
# while z < x:
#     y = y + 2
#     z = z + 1
# {2 * x == y}

# Tím končí důkaz pravdivosti původní trojice.


